<template>
  <div class="p-fluid p-formgrid p-grid">
    <!-- Área de lectura (readonly) -->
    <div class="p-col-12">
      <h3>Área de Lectura</h3>
      <Textarea v-model="readText" :readonly="true" rows="10" placeholder="Este es el área de lectura."
        class="full-width-textarea" />
    </div>

    <!-- Área de escritura -->
    <div class="p-col-12">
      <h3>Área de Escritura</h3>
      <Textarea v-model="writeText" rows="4" placeholder="Escribe aquí algo..." class="full-width-textarea" />
    </div>

    <!-- Botón de envío -->
    <div class="p-col-12">
      <Button label="Enviar" icon="pi pi-send" @click="handleSubmit" />
    </div>

    <!-- Buffer de últimos envíos -->
    <div class="p-col-12">
      <h3>Buffer (últimos 10 envíos)</h3>
      <div v-if="buffer.length === 0">No hay mensajes recientes</div>
      <div v-for="(item, index) in buffer" :key="index" class="p-mb-2">
        <Button class="p-button-text" @click="setBufferText(item)">
          <!-- Mostrar los primeros 20 caracteres del texto -->
          {{ getPreviewText(item) }}
        </Button>
      </div>
    </div>
  </div>
</template>

<script setup lang="ts">
import { inject, onMounted, onBeforeUnmount, ref } from 'vue';
import type { RequestTerminalConnection } from "@/core/types";

import Textarea from 'primevue/textarea';
import Button from 'primevue/button';
import { TYPE_TERMINAL_CONNECTION } from '@/core/consts';

// Traer los datos desde el DynamicDialog data: pluginResult.data
const dialogRef: any = inject("dialogRef");
let params: RequestTerminalConnection

// Definir los datos de estado
const readText = ref<string>('');   // Área de lectura (solo lectura)
const writeText = ref<string>('');  // Área de escritura (editable)
const buffer = ref<string[]>([]);   // Buffer para almacenar los últimos 10 envíos

// Información para conexión por socket
const ws = ref<WebSocket | null>(null);
const isConnected = ref(false);

onMounted(() => {
  // Iniciar las variables desde la referencia
  params = dialogRef.value.data;

  if (params.typeConnection == TYPE_TERMINAL_CONNECTION.WEBSOCKET) {
    const ip = params.data?.ip;
    const port = params.data?.port;
    const user = params.data?.user;
    const password = params.data?.password;
    const endOfCommand = params.data?.endOfCommand;
    //-- START SERVICIOS ASOCIADOS A WEBSOCKET --
    ws.value = new WebSocket("ws://" + ip + ":" + port + "/");

    // Iniciar la conexión por websocket
    ws.value.onopen = async () => {
      isConnected.value = true;
      console.log("onopen")
      // Si necesitas autenticarte, podrías enviar el password aquí
      await sleep(100);
      if (user != "" && user != undefined) {
        ws.value?.send(user + endOfCommand);
        await sleep(100);
      }
      if (password != "" && password != undefined) {
        ws.value?.send(password + endOfCommand);
        await sleep(100);
      }
    };

    // En caso de recibir mensajes
    ws.value.onmessage = (event) => {
      readText.value += event.data;
    }

    // Cerrar conexión websocket
    ws.value.onclose = () => {
      isConnected.value = false;
      // output.value.push("Connection closed.");
      console.log("onclose")
    };

    // En caso de error en la conexión websocket
    ws.value.onerror = (error) => {
      console.error('WebSocket error: ', error);
      // output.value.push("WebSocket error occurred.");
    };
  }
})

onBeforeUnmount(() => {
  // En caso de desmontar el componente, cerrar cualquier conexión existente
  if (ws.value) {
    ws.value.close();
  }
});

// Función para manejar el envío de texto
const handleSubmit = (): void => {
  if (writeText.value.trim() !== '') {
    // Actualizar el área de lectura con el nuevo texto
    // readText.value = writeText.value;
    // Si se estableció una conexión websocket
    if (params.typeConnection == TYPE_TERMINAL_CONNECTION.WEBSOCKET) {
      // Enviar comandos por websocket
      ws.value?.send(writeText.value + params.data?.endOfCommand)
    }

    // Agregar el texto al buffer y mantener solo los últimos 10 elementos
    buffer.value.unshift(writeText.value);
    if (buffer.value.length > 10) {
      buffer.value.pop();
    }

    // Limpiar el área de escritura
    writeText.value = '';
  }
};

// Función para usar un texto del buffer
const setBufferText = (text: string): void => {
  writeText.value = text;
};

// Función para obtener una vista previa de los primeros 20 caracteres del buffer
const getPreviewText = (text: string): string => {
  const preview = text.length > 20 ? text.slice(0, 20) + '...' : text;
  return preview.replace(/\n/g, ' '); // Remover los saltos de línea para el botón de vista previa
};

function sleep(ms: number): Promise<void> {
  return new Promise(resolve => setTimeout(resolve, ms));
}

</script>

<style scoped>
/* Ajustar las áreas de texto al 100% del ancho disponible */
.full-width-textarea {
  width: 100%;
}

.p-col-12 {
  margin-bottom: 1em;
}
</style>
